'use strict';

exports.__esModule = true;

var _always = require('ramda/src/always');

var _always2 = _interopRequireDefault(_always);

var _T = require('ramda/src/T');

var _T2 = _interopRequireDefault(_T);

var _mergeAll = require('ramda/src/mergeAll');

var _mergeAll2 = _interopRequireDefault(_mergeAll);

var _flatten = require('ramda/src/flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _join = require('ramda/src/join');

var _join2 = _interopRequireDefault(_join);

var _sum = require('ramda/src/sum');

var _sum2 = _interopRequireDefault(_sum);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

var _all = require('ramda/src/all');

var _all2 = _interopRequireDefault(_all);

var _cond = require('ramda/src/cond');

var _cond2 = _interopRequireDefault(_cond);

var _curry = require('ramda/src/curry');

var _curry2 = _interopRequireDefault(_curry);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Combines two values of the same type (if it makes sense to combine them).
 * Numbers are summarized, strings and arrays are concatenated together, and
 * true objects are merged (the second value merged on top of the first).
 * In any other case only the first value is returned.
 * 
 * @func
 * @sig a -> a -> a
 * @param {*} val1 The base value to be combined with
 * @param {*} val2 The value to combine
 * @returns {*} If the values are of the same type, this represents the combined
 * value of the two of them. Otherwise only the first value is returned
 */
exports.default = (0, _curry2.default)(function (val1, val2) {
  return (0, _cond2.default)([[(0, _all2.default)((0, _is2.default)(Number)), _sum2.default], [(0, _all2.default)((0, _is2.default)(String)), (0, _join2.default)('')], [(0, _all2.default)((0, _is2.default)(Array)), _flatten2.default], [(0, _all2.default)(_util.isPlainObj), _mergeAll2.default], [_T2.default, (0, _always2.default)(val1)]])([val1, val2]);
});