'use strict';

exports.__esModule = true;

var _identity = require('ramda/src/identity');

var _identity2 = _interopRequireDefault(_identity);

var _converge = require('ramda/src/converge');

var _converge2 = _interopRequireDefault(_converge);

var _curry = require('ramda/src/curry');

var _curry2 = _interopRequireDefault(_curry);

var _combine = require('./combine');

var _combine2 = _interopRequireDefault(_combine);

var _mapSpec = require('./mapSpec');

var _mapSpec2 = _interopRequireDefault(_mapSpec);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Similar to [Ramda's applySpec()](http://ramdajs.com/docs/#applySpec), however
 * the spec will be applied and then merged into the original input.
 * Ramda's applySpec() will omit the original input, returning an object containing _only_
 * the props named in your spec, but this function here will apply the spec
 * and then merge back it into the original input.
 *
 * @func
 * @sig {k: v} -> {k: v} -> {k: v}
 * @param {Object} spec An object whose values are functions which
 * expect the entire object to be fed in as input.
 * This is identical to the input you'd pass into applySpec()
 * @param {Object} input An object to be mapped over (transformed)
 * @returns {Object} The input object with all the transform functions applied at the named keys
 */
exports.default = (0, _curry2.default)(function (spec, value) {
  return (0, _converge2.default)(_combine2.default, [_identity2.default, (0, _mapSpec2.default)(spec)])(value);
});