import _default10 from 'ramda/src/always';
import _default9 from 'ramda/src/T';
import _default8 from 'ramda/src/mergeAll';
import _default7 from 'ramda/src/flatten';
import _default6 from 'ramda/src/join';
import _default5 from 'ramda/src/sum';
import _default4 from 'ramda/src/is';
import _default3 from 'ramda/src/all';
import _default2 from 'ramda/src/cond';
import _default from 'ramda/src/curry';

import { isPlainObj } from './util';

/**
 * Combines two values of the same type (if it makes sense to combine them).
 * Numbers are summarized, strings and arrays are concatenated together, and
 * true objects are merged (the second value merged on top of the first).
 * In any other case only the first value is returned.
 * 
 * @func
 * @sig a -> a -> a
 * @param {*} val1 The base value to be combined with
 * @param {*} val2 The value to combine
 * @returns {*} If the values are of the same type, this represents the combined
 * value of the two of them. Otherwise only the first value is returned
 */
export default _default(function (val1, val2) {
  return _default2([[_default3(_default4(Number)), _default5], [_default3(_default4(String)), _default6('')], [_default3(_default4(Array)), _default7], [_default3(isPlainObj), _default8], [_default9, _default10(val1)]])([val1, val2]);
});